'----------------------------------------------------------
' LCWALLS.BAS
'
' E-mail: lucoslo@hotmail.com
'
' Videogame (risoluzione grafica 320 x 200, 16 colori).
'
' Dicembre 2002.
'----------------------------------------------------------

DEFINT A-Z

' dichiarazione delle procedure
DECLARE SUB ImpostaSchermo ()
DECLARE SUB LeggiPersonaggio ()
DECLARE SUB LeggiMuro ()
DECLARE SUB LeggiNemico1 ()
DECLARE SUB LeggiNemico2 ()
DECLARE SUB LeggiMedaglia1 ()
DECLARE SUB LeggiMedaglia2 ()
DECLARE SUB LeggiMagia1 ()
DECLARE SUB LeggiMagia2 ()
DECLARE SUB LeggiMagia3 ()
DECLARE SUB SchermataBenvenuto ()
DECLARE SUB Introduzione ()
DECLARE SUB Schema (x%)
DECLARE SUB PassaggioSchema ()
DECLARE SUB ScriviPersonaggio ()
DECLARE SUB ScriviMuro ()
DECLARE SUB ScriviNemico1 ()
DECLARE SUB ScriviNemico2 ()
DECLARE SUB ScriviMedaglia1 ()
DECLARE SUB ScriviMedaglia2 ()
DECLARE SUB ScriviMagia1 ()
DECLARE SUB ScriviMagia2 ()
DECLARE SUB ScriviMagia3 ()
DECLARE SUB SuonoMedaglia1 ()
DECLARE SUB SuonoMedaglia2 ()
DECLARE SUB SuonoNoMedaglia ()
DECLARE SUB SuonoMagia ()
DECLARE SUB SuonoVittoria ()
DECLARE SUB SuonoSconfitta ()
DECLARE SUB Gioca ()
DECLARE SUB HaiPerso ()
DECLARE SUB HaiVinto ()

' costanti
CONST larghp = 10          ' larghezza del personaggio
CONST altp = 10            ' altezza del personaggio
CONST puntimedaglia1 = 10  ' punti per ogni medaglia di tipo 1
CONST puntimedaglia2 = 30  ' punti per ogni medaglia di tipo 2
CONST puntimagie = 30      ' punti per ogni magia di tipo 1, 2 o 3
CONST larghmuro = 10       ' larghezza del muro
CONST altmuro = 10         ' altezza del muro
CONST puntinegmuro = 2     ' punti da togliere quando si attraversa un muro
CONST larghnemici = 10     ' larghezza dei nemici
CONST altnemici = 10       ' altezza dei nemici
CONST totnemici1 = 10      ' numero massimo di nemici di tipo 1
CONST totnemici2 = 10      ' numero massimo di nemici di tipo 2
CONST pausanemici = .3     ' attesa per muovere i nemici
CONST larghmedaglie = 10   ' larghezza delle medaglie
CONST altmedaglie = 10     ' altezza delle medaglie
CONST totmedaglie1 = 10    ' numero massimo di medaglie di tipo 1
CONST totmedaglie2 = 10    ' numero massimo di medaglie di tipo 2
CONST larghmagie = 10      ' larghezza delle magie
CONST altmagie = 10        ' altezza delle magie
CONST totmagie1 = 2        ' numero massimo di magie di tipo 1
CONST totmagie2 = 2        ' numero massimo di magie di tipo 2
CONST totmagie3 = 2        ' numero massimo di magie di tipo 3
CONST maxx = 319           ' coordinata x massima
CONST maxy = 199           ' coordinata y massima
CONST coloresfondo = 0     ' colore dello sfondo
CONST colorebordo = 4      ' colore del bordo
CONST larghschema = 32     ' larghezza degli schemi
CONST altschema = 20       ' altezza degli schemi
CONST facilitamassima = 10 ' massima facilita' di uno schema
CONST puntischema = 500    ' punti per passaggio di uno schema
CONST schemitotali = 10    ' numero degli schemi

' variabili globali
' personaggio
DIM SHARED p(1 TO altp, 1 TO larghp)
DIM SHARED xpold, ypold, xpnew, ypnew
DIM SHARED punti, maxpunti
' muro
DIM SHARED m(1 TO altmuro, 1 TO larghmuro)
DIM SHARED xm, ym
' nemici di tipo 1
DIM SHARED n1(1 TO altnemici, 1 TO larghnemici)
DIM SHARED xn1(1 TO totnemici1), yn1(1 TO totnemici1)
DIM SHARED salvaxn1, salvayn1
DIM SHARED contanemici1
' nemici di tipo 2
DIM SHARED n2(1 TO altnemici, 1 TO larghnemici)
DIM SHARED xn2(1 TO totnemici2), yn2(1 TO totnemici2)
DIM SHARED salvaxn2, salvayn2
DIM SHARED contanemici2
' medaglie di tipo 1
DIM SHARED g1(1 TO altmedaglie, 1 TO larghmedaglie)
DIM SHARED xg1(1 TO totmedaglie1), yg1(1 TO totmedaglie1)
DIM SHARED contamedaglie1
' medaglie di tipo 2
DIM SHARED g2(1 TO altmedaglie, 1 TO larghmedaglie)
DIM SHARED xg2(1 TO totmedaglie2), yg2(1 TO totmedaglie2)
DIM SHARED contamedaglie2
' magie di tipo 1
DIM SHARED e1(1 TO altmagie, 1 TO larghmagie)
DIM SHARED xe1(1 TO totmagie1), ye1(1 TO totmagie1)
DIM SHARED contamagie1
' magie di tipo 2
DIM SHARED e2(1 TO altmagie, 1 TO larghmagie)
DIM SHARED xe2(1 TO totmagie2), ye2(1 TO totmagie2)
DIM SHARED contamagie2
' magie di tipo 3
DIM SHARED e3(1 TO altmagie, 1 TO larghmagie)
DIM SHARED xe3(1 TO totmagie3), ye3(1 TO totmagie3)
DIM SHARED contamagie3
' schema
DIM SHARED s(1 TO larghschema, 1 TO altschema)
DIM SHARED facilitaschema, numnemici1schema, numnemici2schema
DIM SHARED medaglieprese, medaglie1daprendere, medaglie2daprendere
DIM SHARED magie1daprendere, magie2daprendere, magie3daprendere, contaschema

ImpostaSchermo
LeggiPersonaggio
LeggiMuro
LeggiNemico1
LeggiNemico2
LeggiMedaglia1
LeggiMedaglia2
LeggiMagia1
LeggiMagia2
LeggiMagia3
SchermataBenvenuto
Gioca

END

' dati relativi al personaggio, ai muri, ai nemici, alle medaglie
' e alle magie

Personaggio:
DATA 0, 0, 0, 4, 4, 4, 4, 0, 0, 0
DATA 0, 0, 0, 4, 2, 2, 4, 0, 0, 0
DATA 0, 0, 0, 4, 4, 4, 4, 0, 0, 0
DATA 0, 0, 0, 0, 4, 4, 0, 0, 0, 0
DATA 0, 0, 4, 4, 4, 4, 4, 4, 0, 0
DATA 0, 0, 4, 0, 4, 4, 0, 4, 0, 0
DATA 0, 0, 4, 0, 4, 4, 0, 4, 0, 0
DATA 0, 0, 0, 0, 4, 4, 0, 0, 0, 0
DATA 0, 0, 0, 4, 4, 4, 4, 0, 0, 0
DATA 0, 4, 4, 4, 4, 4, 4, 4, 4, 0

Muro:
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 2, 2, 2, 2, 2, 2, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 1, 1, 1, 1, 1, 1, 2, 1
DATA 1, 2, 2, 2, 2, 2, 2, 2, 2, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Nemico1:
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 3, 0, 3, 0, 3, 0, 3, 0, 3, 0
DATA 0, 3, 0, 3, 0, 3, 0, 3, 0, 3
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0

Nemico2:
DATA 0, 3, 3, 3, 3, 3, 3, 3, 3, 0
DATA 0, 3, 0, 3, 3, 3, 3, 0, 3, 0
DATA 0, 3, 0, 0, 3, 3, 0, 0, 3, 0
DATA 0, 3, 0, 0, 3, 0, 0, 0, 3, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 3, 0, 0, 0, 0
DATA 0, 0, 0, 0, 3, 0, 0, 0, 0, 0

Medaglia1:
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 2, 2, 2, 2, 2, 2, 0, 0
DATA 0, 0, 2, 6, 6, 6, 6, 2, 0, 0
DATA 0, 0, 2, 6, 6, 6, 6, 2, 0, 0
DATA 0, 0, 2, 6, 6, 6, 6, 2, 0, 0
DATA 0, 0, 2, 6, 6, 6, 6, 2, 0, 0
DATA 0, 0, 2, 2, 2, 2, 2, 2, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

Medaglia2:
DATA 0, 0, 0, 0, 6, 6, 0, 0, 0, 0
DATA 0, 0, 0, 6, 2, 2, 6, 0, 0, 0
DATA 0, 0, 6, 2, 2, 2, 2, 6, 0, 0
DATA 0, 6, 2, 0, 0, 0, 0, 2, 6, 0
DATA 0, 6, 2, 0, 0, 0, 0, 2, 6, 0
DATA 0, 6, 2, 0, 0, 0, 0, 2, 6, 0
DATA 0, 6, 2, 0, 0, 0, 0, 2, 6, 0
DATA 0, 0, 6, 2, 0, 0, 2, 6, 0, 0
DATA 0, 0, 0, 6, 2, 2, 6, 0, 0, 0
DATA 0, 0, 0, 0, 6, 6, 0, 0, 0, 0

Magia1:
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

Magia2:
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

Magia3:
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 7, 0, 0, 0, 0, 0, 0, 7, 0
DATA 0, 7, 7, 7, 7, 7, 7, 7, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

' da qui in poi ci sono gli schemi.
' legenda:
'   i primi otto numeri sono: facilitaschema, numnemici1schema,
'   numnemici2schema, medaglie1daprendere, medaglie2daprendere,
'   magie1daprendere, magie2daprendere e magie3daprendere;
'   gli altri numeri rappresentano lo schema:
'     0 nulla
'     1 muro
'     2 personaggio
'     3 nemico di tipo 1
'     4 nemico di tipo 2
'     5 medaglia di tipo 1
'     6 medaglia di tipo 2
'     7 magia di tipo 1
'     8 magia di tipo 2
'     9 magia di tipo 3

Schema1:
DATA 5, 6, 0, 5, 0, 0, 0, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 1, 5, 0, 0, 1, 0, 0, 3, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 3, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1
DATA 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema2:
DATA 5, 6, 2, 5, 2, 0, 1, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 1, 5, 0, 0, 1, 0, 3, 0, 0, 0, 1, 0, 0, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 3, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 4, 1, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 3, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1
DATA 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 6, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema3:
DATA 5, 6, 4, 5, 5, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 1, 5, 0, 0, 1, 0, 3, 0, 0, 0, 1, 6, 0, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 3, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 4, 1, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 3, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 6, 0, 0, 6, 0, 0, 0, 0, 0, 1, 0, 9, 0, 1
DATA 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 7, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 4, 1, 1, 4, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0, 1
DATA 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 6, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1
DATA 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema4:
DATA 4, 6, 0, 5, 0, 0, 0, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 1, 0, 0, 1, 5, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 1, 3, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 5, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1
DATA 1, 0, 0, 3, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 5, 1, 0, 1, 0, 5, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema5:
DATA 4, 6, 2, 5, 2, 0, 1, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 1, 0, 0, 1, 5, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 1, 3, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 4, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 6, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 4, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 5, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1
DATA 1, 0, 0, 3, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 8, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 5, 1, 0, 1, 0, 5, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 6, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema6:
DATA 4, 6, 4, 5, 5, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 1, 0, 0, 1, 5, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 1, 3, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 4, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 6, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 4, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 6, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 5, 9, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1
DATA 1, 0, 0, 3, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 3, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 5, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 4, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1
DATA 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 8, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 5, 1, 0, 1, 0, 5, 0, 1, 0, 1, 4, 0, 0, 0, 0, 0, 6, 1, 0, 1, 0, 7, 0, 0, 0, 0, 0, 6, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema7:
DATA 3, 5, 5, 8, 8, 0, 1, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 0, 1, 3, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1
DATA 1, 1, 1, 1, 1, 0, 1, 5, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 3, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 8, 0, 1
DATA 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 5, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 6, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 1, 0, 0, 1
DATA 1, 4, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 4, 0, 0, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 5, 1, 5, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 0, 1, 0, 0, 0, 0, 1, 6, 1, 6, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 6, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 3, 0, 6, 1
DATA 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 1
DATA 1, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema8:
DATA 3, 8, 8, 10, 10, 0, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 0, 1, 3, 4, 0, 0, 0, 0, 0, 0, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 1
DATA 1, 1, 1, 1, 1, 0, 1, 5, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 3, 1, 0, 1, 5, 1, 0, 1, 0, 1, 0, 0, 1, 8, 0, 1
DATA 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 9, 1, 6, 0, 0, 1, 5, 0, 0, 1, 5, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 6, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 1, 0, 0, 1
DATA 1, 4, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 4, 0, 0, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 5, 1, 5, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 0, 1, 0, 0, 0, 0, 1, 6, 1, 6, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 6, 0, 0, 4, 0, 1, 0, 1, 0, 1, 0, 3, 0, 6, 1
DATA 1, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 1
DATA 1, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema9:
DATA 3, 8, 8, 10, 10, 0, 0, 0
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 0, 1, 3, 4, 0, 0, 0, 0, 0, 0, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 1
DATA 1, 1, 1, 1, 1, 0, 1, 5, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 3, 1, 0, 1, 5, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1
DATA 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 6, 0, 0, 1, 5, 0, 0, 1, 5, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 6, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 1, 0, 0, 1
DATA 1, 4, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 4, 0, 0, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1
DATA 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1
DATA 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 5, 1, 5, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 0, 1, 0, 0, 0, 0, 1, 6, 1, 6, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 6, 0, 0, 4, 0, 1, 0, 1, 0, 1, 0, 3, 0, 6, 1
DATA 1, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 1
DATA 1, 5, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

Schema10:
DATA 2, 10, 10, 10, 10, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 1, 9, 4, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 4, 0, 4, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 6, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1
DATA 1, 0, 1, 0, 5, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 3, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0, 6, 1, 0, 1, 0, 0, 0, 0, 0, 1
DATA 1, 3, 1, 0, 5, 0, 1, 0, 3, 0, 1, 5, 5, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1
DATA 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 6, 1, 6, 0, 0, 1, 0, 0, 0, 1
DATA 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 4, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 6, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 4, 1, 5, 4, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 5, 0, 0, 0, 0, 0, 1, 0, 0, 5, 0, 1, 0, 1, 7, 0, 0, 0, 8, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 3, 3, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 3, 1, 0, 0, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 0, 1, 6, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 0, 5, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1
DATA 1, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1
DATA 1, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1

SUB Gioca
' procedura principale del gioco

' inizializzazioni generali
contaschema = 1
punti = 0
maxpunti = 0
RANDOMIZE TIMER

DO
 ' inizializzazioni di schema
 paralizzanemici2 = 0
 muridaria = 0
 medaglieprese = 0

 ' richiama lo schema appropriato
 CALL Schema(contaschema)

 ' loop principale
 DO
  ' loop di attesa per evitare che i nemici si muovano troppo rapidamente
  t! = TIMER
  DO
   ' legge l'input da tastiera (tasti freccia per muoversi ed ESC per uscire)
   scelta$ = INKEY$
   SELECT CASE scelta$
    CASE CHR$(0) + "H": ypnew = ypold - 1
    CASE CHR$(0) + "M": xpnew = xpold + 1
    CASE CHR$(0) + "K": xpnew = xpold - 1
    CASE CHR$(0) + "P": ypnew = ypold + 1
    CASE "p": SLEEP
    CASE "P": SLEEP
    CASE CHR$(27): END
   END SELECT
   ' controlla che non ci sia un muro e se i muri sono d'aria che
   ' non esca dallo schermo
   IF ((s(xpnew, ypnew) = 1) AND (muridaria = 0)) THEN
    xpnew = xpold
    ypnew = ypold
   END IF
   IF ((s(xpnew, ypnew) = 1) AND (muridaria = 1)) THEN
    IF ((xpnew <= 1) OR (xpnew >= 32) OR (ypnew <= 1) OR (ypnew >= 20)) THEN
     xpnew = xpold
     ypnew = ypold
    END IF
   END IF
   ' controlla che le nuove coordinate siano diverse da quelle vecchie
   IF ((xpnew <> xpold) OR (ypnew <> ypold)) THEN
    ScriviPersonaggio
    ' se ho oltrepassato un muro togli un po' di punti
    IF (s(xpnew, ypnew) = 1) THEN punti = punti - puntinegmuro
    ' controlla se hai preso una medaglia
    IF (s(xpnew, ypnew) = 5) THEN
     medaglieprese = medaglieprese + 1
     punti = punti + puntimedaglia1
     SuonoMedaglia1
    END IF
    IF (s(xpnew, ypnew) = 6) THEN
     medaglieprese = medaglieprese + 1
     punti = punti + puntimedaglia2
     SuonoMedaglia2
    END IF
    ' controlla di non essere finito sopra ad un nemico
    IF ((s(xpnew, ypnew) = 3) OR (s(xpnew, ypnew) = 4)) THEN
     SuonoSconfitta
     HaiPerso
    END IF
    ' controlla se hai preso una magia
    IF (s(xpnew, ypnew) = 7) THEN
     punti = punti + puntimagie
     facilitaschema = facilitamassima
     SuonoMagia
    END IF
    IF (s(xpnew, ypnew) = 8) THEN
     punti = punti + puntimagie
     paralizzanemici2 = 1
     SuonoMagia
    END IF
    IF (s(xpnew, ypnew) = 9) THEN
     punti = punti + puntimagie
     muridaria = 1
     SuonoMagia
    END IF
    ' aggiorna la posizione effettiva
    s(xpnew, ypnew) = 2
    s(xpold, ypold) = 0
   END IF
   ' aggiorna le coordinate vecchie del personaggio
   xpold = xpnew: ypold = ypnew
  LOOP WHILE TIMER < t! + pausanemici
 
  ' muovi i nemici di tipo 1
  FOR i = 1 TO numnemici1schema
   salvaxn1 = xn1(i): salvayn1 = yn1(i)
   mossamaliziosa = INT(RND * facilitaschema)
   IF (mossamaliziosa = 0) THEN
    IF (xpold < xn1(i)) THEN
     xn1(i) = xn1(i) - 1
    ELSE
     IF (xpold > xn1(i)) THEN
      xn1(i) = xn1(i) + 1
     ELSE
      IF (ypold < yn1(i)) THEN
       yn1(i) = yn1(i) - 1
      ELSE
       IF (ypold > yn1(i)) THEN yn1(i) = yn1(i) + 1
      END IF
     END IF
    END IF
   ELSE
    mossanemico = INT(RND * 4)
    SELECT CASE mossanemico
     CASE 0: yn1(i) = yn1(i) - 1
     CASE 1: xn1(i) = xn1(i) + 1
     CASE 2: xn1(i) = xn1(i) - 1
     CASE 3: yn1(i) = yn1(i) + 1
    END SELECT
   END IF
   ' controlla che non ci sia un muro, un altro nemico o qualche magia
   IF ((s(xn1(i), yn1(i)) = 1) OR (s(xn1(i), yn1(i)) = 3) OR (s(xn1(i), yn1(i)) = 4) OR (s(xn1(i), yn1(i)) = 7) OR (s(xn1(i), yn1(i)) = 8) OR (s(xn1(i), yn1(i)) = 9)) THEN
    xn1(i) = salvaxn1
    yn1(i) = salvayn1
   END IF
   ' controlla che le coordinate vecchie siano diverse da quelle nuove
   IF ((xn1(i) <> salvaxn1) OR (yn1(i) <> salvayn1)) THEN
    contanemici1 = i
    ScriviNemico1
    ' controlla se hanno preso una medaglia
    IF ((s(xn1(i), yn1(i)) = 5) OR (s(xn1(i), yn1(i)) = 6)) THEN
     medaglieprese = medaglieprese + 1
     SuonoNoMedaglia
    END IF
    ' controlla di non aver preso il personaggio
    IF (s(xn1(i), yn1(i)) = 2) THEN
     SuonoSconfitta
     HaiPerso
    END IF
    ' aggiorna la posizione effettiva
    s(xn1(i), yn1(i)) = 3
    s(salvaxn1, salvayn1) = 0
   END IF
  NEXT i

  ' muovi i nemici di tipo 2
  IF (paralizzanemici2 = 0) THEN
   FOR i = 1 TO numnemici2schema
    salvaxn2 = xn2(i): salvayn2 = yn2(i)
    mossamaliziosa = INT(RND * facilitaschema)
    IF (mossamaliziosa = 0) THEN
     IF (xpold < xn2(i)) THEN xn2(i) = xn2(i) - 1
     IF (xpold > xn2(i)) THEN xn2(i) = xn2(i) + 1
     IF (ypold < yn2(i)) THEN yn2(i) = yn2(i) - 1
     IF (ypold > yn2(i)) THEN yn2(i) = yn2(i) + 1
    ELSE
     mossanemico = INT(RND * 8)
     SELECT CASE mossanemico
      CASE 0: yn2(i) = yn2(i) - 1
      CASE 1: xn2(i) = xn2(i) + 1
      CASE 2: xn2(i) = xn2(i) - 1
      CASE 3: yn2(i) = yn2(i) + 1
      CASE 4: xn2(i) = xn2(i) + 1: yn2(i) = yn2(i) - 1
      CASE 5: xn2(i) = xn2(i) + 1: yn2(i) = yn2(i) + 1
      CASE 6: xn2(i) = xn2(i) - 1: yn2(i) = yn2(i) + 1
      CASE 7: xn2(i) = xn2(i) - 1: yn2(i) = yn2(i) - 1
     END SELECT
    END IF
    ' controlla che non ci sia un muro, un altro nemico o qualche magia
    IF ((s(xn2(i), yn2(i)) = 1) OR (s(xn2(i), yn2(i)) = 3) OR (s(xn2(i), yn2(i)) = 4) OR (s(xn2(i), yn2(i)) = 7) OR (s(xn2(i), yn2(i)) = 8) OR (s(xn2(i), yn2(i)) = 9)) THEN
     xn2(i) = salvaxn2
     yn2(i) = salvayn2
    END IF
    ' controlla che le coordinate vecchie siano diverse da quelle nuove
    IF ((xn2(i) <> salvaxn2) OR (yn2(i) <> salvayn2)) THEN
     contanemici2 = i
     ScriviNemico2
     ' controlla se hanno preso una medaglia
     IF ((s(xn2(i), yn2(i)) = 5) OR (s(xn2(i), yn2(i)) = 6)) THEN
      medaglieprese = medaglieprese + 1
      SuonoNoMedaglia
     END IF
     ' controlla di non aver preso il personaggio
     IF (s(xn2(i), yn2(i)) = 2) THEN
      SuonoSconfitta
      HaiPerso
     END IF
     ' aggiorna la posizione effettiva
     s(xn2(i), yn2(i)) = 4
     s(salvaxn2, salvayn2) = 0
    END IF
   NEXT i
  END IF

 LOOP WHILE medaglieprese < (medaglie1daprendere + medaglie2daprendere) ' per uscire dallo schema
 punti = punti + puntischema
 contaschema = contaschema + 1
LOOP WHILE contaschema <= schemitotali

' se sei arrivato fino a qui vuol dire che...
HaiVinto

END SUB

SUB HaiPerso
' la partita termina perche' si e' stati sconfitti

' fai un box nello schermo
FOR i = 0 TO 5
 LINE (30 + i, 30 + i)-(290 - i, 132 - i), colorebordo, B
NEXT i
LINE (36, 36)-(284, 126), coloresfondo, BF

LOCATE 8, 7: PRINT "Hai perso!"
LOCATE 10, 7: PRINT "Schema:";
PRINT contaschema;
PRINT "di";
PRINT schemitotali
LOCATE 11, 7: PRINT "Punteggio:";
PRINT punti
t! = TIMER
DO
LOOP WHILE (TIMER < t! + 2)
LOCATE 13, 7: PRINT "Premi un tasto per uscire..."
SLEEP

END

END SUB

SUB HaiVinto
' complimenti...

' fai un box nello schermo
FOR i = 0 TO 5
 LINE (30 + i, 30 + i)-(290 - i, 132 - i), colorebordo, B
NEXT i
LINE (36, 36)-(284, 126), coloresfondo, BF

LOCATE 8, 7: PRINT "Hai vinto!!!"
LOCATE 10, 7: PRINT "Schema:";
PRINT contaschema - 1;
PRINT "di";
PRINT schemitotali
LOCATE 11, 7: PRINT "Punteggio:";
PRINT punti;
PRINT "su";
PRINT maxpunti
t! = TIMER
DO
LOOP WHILE (TIMER < t! + 2)
LOCATE 13, 7: PRINT "Premi un tasto per uscire..."
SLEEP

END


END SUB

SUB ImpostaSchermo
' imposta la modalita' dello schermo

' modalita' 13: 640 * 480 con 16 attributi di colore
SCREEN 13

END SUB

SUB Introduzione
' spiegazione del gioco

' pagina 1
' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

' bordo
FOR i = 0 TO 5
 LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
NEXT i

' personaggio
LOCATE 3, 4: PRINT "LCWALLS"
LOCATE 5, 4: PRINT "E-mail: lucoslo@hotmail.com"
LOCATE 7, 4: PRINT "Pagina 1 di 4"
xpnew = 5: ypnew = 8
ScriviPersonaggio
LOCATE 13, 4: PRINT "* Ci si muove con i tasti freccia."
LOCATE 14, 4: PRINT "* Con p o P il gioco va in pausa,"
LOCATE 15, 4: PRINT "  per riprendere premere un tasto."
LOCATE 16, 4: PRINT "* Con ESC si esce durante il gioco."
LOCATE 19, 4: PRINT "Premere un tasto per continuare..."
SLEEP

' pagina 2
' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

' bordo
FOR i = 0 TO 5
 LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
NEXT i

' nemici
LOCATE 3, 4: PRINT "LCWALLS"
LOCATE 5, 4: PRINT "E-mail: lucoslo@hotmail.com"
LOCATE 7, 4: PRINT "Pagina 2 di 4"
contanemici1 = 1
xn1(contanemici1) = 5: yn1(contanemici1) = 8
ScriviNemico1
contanemici2 = 1
xn2(contanemici2) = 7: yn2(contanemici2) = 8
ScriviNemico2
LOCATE 13, 4: PRINT "* Evita il contatto con i nemici."
LOCATE 14, 4: PRINT "* I secondi si muovono anche in"
LOCATE 15, 4: PRINT "  diagonale."
LOCATE 18, 4: PRINT "Premere un tasto per continuare..."
SLEEP

' pagina 3
' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

' bordo
FOR i = 0 TO 5
 LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
NEXT i

' medaglie
LOCATE 3, 4: PRINT "LCWALLS"
LOCATE 5, 4: PRINT "E-mail: lucoslo@hotmail.com"
LOCATE 7, 4: PRINT "Pagina 3 di 4"
contamedaglie1 = 1
xg1(contamedaglie1) = 5: yg1(contamedaglie1) = 8
ScriviMedaglia1
contamedaglie2 = 1
xg2(contamedaglie2) = 7: yg2(contamedaglie2) = 8
ScriviMedaglia2
LOCATE 13, 4: PRINT "* Devi prendere queste medaglie"
LOCATE 14, 4: PRINT "  per passare gli schemi."
LOCATE 15, 4: PRINT "* Le prime valgono";
PRINT puntimedaglia1;
PRINT "punti."
LOCATE 16, 4: PRINT "* Le seconde valgono";
PRINT puntimedaglia2;
PRINT "punti."
LOCATE 17, 4: PRINT "* I nemici le possono prendere."
LOCATE 18, 4: PRINT "* Ogni schema che passi hai";
PRINT puntischema
LOCATE 19, 4: PRINT "  punti."
LOCATE 20, 4: PRINT "* Ci sono";
PRINT schemitotali;
PRINT "schemi."
LOCATE 23, 4: PRINT "Premere un tasto per continuare..."
SLEEP

' pagina 4
' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

' bordo
FOR i = 0 TO 5
 LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
NEXT i

' magie
LOCATE 3, 4: PRINT "LCWALLS"
LOCATE 5, 4: PRINT "E-mail: lucoslo@hotmail.com"
LOCATE 7, 4: PRINT "Pagina 4 di 4"
contamagie1 = 1
xe1(contamagie1) = 5: ye1(contamagie1) = 8
ScriviMagia1
contamagie2 = 1
xe2(contamagie2) = 7: ye2(contamagie2) = 8
ScriviMagia2
contamagie3 = 1
xe3(contamagie3) = 9: ye3(contamagie3) = 8
ScriviMagia3
LOCATE 13, 4: PRINT "* Cerca di prendere queste 'magie'."
LOCATE 14, 4: PRINT "* Le prime disorientano i nemici."
LOCATE 15, 4: PRINT "* Le seconde fermano i nemici"
LOCATE 16, 4: PRINT "  di tipo 2."
LOCATE 17, 4: PRINT "* le terze ti fanno passare i muri."
LOCATE 18, 4: PRINT "* Tutte valgono";
PRINT puntimagie;
PRINT "punti."
LOCATE 19, 4: PRINT "* Ogni muro che passi perdi";
PRINT puntinegmuro;
PRINT "punti."
LOCATE 20, 4: PRINT "* I nemici non le possono prendere."
LOCATE 23, 4: PRINT "Premere un tasto per terminare..."
SLEEP

' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

END SUB

SUB LeggiMagia1
' leggi le magie di tipo 1

RESTORE Magia1
FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  READ e1(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiMagia2
' leggi le magie di tipo 2

RESTORE Magia2
FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  READ e2(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiMagia3
' leggi le magie di tipo 3

RESTORE Magia3
FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  READ e3(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiMedaglia1
' leggi le medaglie di tipo 1

RESTORE Medaglia1
FOR i = 1 TO altmedaglie
 FOR j = 1 TO larghmedaglie
  READ g1(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiMedaglia2
' leggi le medaglie di tipo 2

RESTORE Medaglia2
FOR i = 1 TO altmedaglie
 FOR j = 1 TO larghmedaglie
  READ g2(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiMuro

RESTORE Muro
FOR i = 1 TO altmuro
 FOR j = 1 TO larghmuro
  READ m(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiNemico1
' leggi i nemici di tipo 1

RESTORE Nemico1
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  READ n1(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiNemico2
' leggi i nemici di tipo 2

RESTORE Nemico2
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  READ n2(i, j)
 NEXT j
NEXT i

END SUB

SUB LeggiPersonaggio
' crea il personaggio

' legge il personaggio (usando DATA)
RESTORE Personaggio
FOR i = 1 TO altp
 FOR j = 1 TO larghp
  READ p(i, j)
 NEXT j
NEXT i

END SUB

SUB PassaggioSchema
' schermata tra uno schema e l'altro

' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

' bordo
FOR i = 0 TO 5
 LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
NEXT i

' dati della partita
LOCATE 5, 4: PRINT "LCWALLS"
LOCATE 7, 4: PRINT "E-mail: lucoslo@hotmail.com"
LOCATE 10, 4: PRINT "Punteggio          : "
LOCATE 10, 25: PRINT punti;
PRINT "su";
PRINT maxpunti
LOCATE 11, 4: PRINT "Schema             : "
LOCATE 11, 25: PRINT contaschema
LOCATE 12, 4: PRINT "Nemici di tipo 1   : "
LOCATE 12, 25: PRINT numnemici1schema
LOCATE 13, 4: PRINT "Nemici di tipo 2   : "
LOCATE 13, 25: PRINT numnemici2schema
LOCATE 14, 4: PRINT "Medaglie di tipo 1 : "
LOCATE 14, 25: PRINT medaglie1daprendere
LOCATE 15, 4: PRINT "Medaglie di tipo 2 : "
LOCATE 15, 25: PRINT medaglie2daprendere
LOCATE 16, 4: PRINT "Magie di tipo 1    : "
LOCATE 16, 25: PRINT magie1daprendere
LOCATE 17, 4: PRINT "Magie di tipo 2    : "
LOCATE 17, 25: PRINT magie2daprendere
LOCATE 18, 4: PRINT "Magie di tipo 3    : "
LOCATE 18, 25: PRINT magie3daprendere
t! = TIMER
DO
LOOP WHILE (TIMER < t! + 2)
LOCATE 21, 4: PRINT "Premere un tasto per procedere..."
SLEEP

' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

END SUB

SUB Schema (x%)
' crea il generico schema

IF (x% = 1) THEN RESTORE Schema1
IF (x% = 2) THEN RESTORE Schema2
IF (x% = 3) THEN RESTORE Schema3
IF (x% = 4) THEN RESTORE Schema4
IF (x% = 5) THEN RESTORE Schema5
IF (x% = 6) THEN RESTORE Schema6
IF (x% = 7) THEN RESTORE Schema7
IF (x% = 8) THEN RESTORE Schema8
IF (x% = 9) THEN RESTORE Schema9
IF (x% = 10) THEN RESTORE Schema10

READ facilitaschema
READ numnemici1schema
READ numnemici2schema
READ medaglie1daprendere
READ medaglie2daprendere
READ magie1daprendere
READ magie2daprendere
READ magie3daprendere

PassaggioSchema
maxpunti = maxpunti + (medaglie1daprendere * puntimedaglia1) + (medaglie2daprendere * puntimedaglia2) + ((magie1daprendere + magie2daprendere + magie3daprendere) * puntimagie) + puntischema

contanemici1 = 1: contanemici2 = 1
contamedaglie1 = 1: contamedaglie2 = 1
contamagie1 = 1: contamagie2 = 1: contamagie3 = 1

FOR j = 1 TO altschema
 FOR i = 1 TO larghschema
  READ s(i, j)
  IF (s(i, j) = 1) THEN
   xm = i: ym = j
   CALL ScriviMuro
  END IF
  IF (s(i, j) = 2) THEN
   xpnew = i: ypnew = j
   xpold = xpnew: ypold = ypnew
   CALL ScriviPersonaggio
  END IF
  IF (s(i, j) = 3) THEN
   xn1(contanemici1) = i: yn1(contanemici1) = j
   CALL ScriviNemico1
   contanemici1 = contanemici1 + 1
  END IF
  IF (s(i, j) = 4) THEN
   xn2(contanemici2) = i: yn2(contanemici2) = j
   CALL ScriviNemico2
   contanemici2 = contanemici2 + 1
  END IF
  IF (s(i, j) = 5) THEN
   xg1(contamedaglie1) = i: yg1(contamedaglie1) = j
   CALL ScriviMedaglia1
   contamedaglie1 = contamedaglie1 + 1
  END IF
  IF (s(i, j) = 6) THEN
   xg2(contamedaglie2) = i: yg2(contamedaglie2) = j
   CALL ScriviMedaglia2
   contamedaglie2 = contamedaglie2 + 1
  END IF
  IF (s(i, j) = 7) THEN
   xe1(contamagie1) = i: ye1(contamagie1) = j
   CALL ScriviMagia1
   contamagie1 = contamagie1 + 1
  END IF
  IF (s(i, j) = 8) THEN
   xe2(contamagie2) = i: ye2(contamagie2) = j
   CALL ScriviMagia2
   contamagie2 = contamagie2 + 1
  END IF
  IF (s(i, j) = 9) THEN
   xe3(contamagie3) = i: ye3(contamagie3) = j
   CALL ScriviMagia3
   contamagie3 = contamagie3 + 1
  END IF
 NEXT i
NEXT j

END SUB

SUB SchermataBenvenuto
' schermata iniziale

DO
 ' sfondo
 FOR i = 0 TO 319
  FOR j = 0 TO 199
   PSET (i, j), coloresfondo
  NEXT j
 NEXT i

 ' bordo
 FOR i = 0 TO 5
  LINE (0 + i, 0 + i)-(319 - i, 199 - i), colorebordo, B
 NEXT i

 ' opzioni
 LOCATE 5, 4: PRINT "LCWALLS"
 LOCATE 7, 4: PRINT "E-mail: lucoslo@hotmail.com"
 LOCATE 10, 4: PRINT "1) Introduzione"
 LOCATE 11, 4: PRINT "2) Gioca"
 LOCATE 12, 4: PRINT "3) Esci"
 LOCATE 15, 4: PRINT "Effettuare la propria scelta..."
 DO
  scelta$ = INKEY$
 LOOP UNTIL ((scelta$ = "1") OR (scelta$ = "2") OR (scelta$ = "3"))

 IF (scelta$ = "1") THEN Introduzione
 IF (scelta$ = "3") THEN END
LOOP UNTIL (scelta$ = "2")

' sfondo
FOR i = 0 TO 319
 FOR j = 0 TO 199
  PSET (i, j), coloresfondo
 NEXT j
NEXT i

END SUB

SUB ScriviMagia1
' scrivi le magie di tipo 1

FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  IF (e1(i, j) = 0) THEN
   PSET (((xe1(contamagie1) - 1) * larghmagie) + j - 1, ((ye1(contamagie1) - 1) * altmagie) + i - 1), coloresfondo
  ELSE
   PSET (((xe1(contamagie1) - 1) * larghmagie) + j - 1, ((ye1(contamagie1) - 1) * altmagie) + i - 1), e1(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviMagia2
' scrivi le magie di tipo 2

FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  IF (e2(i, j) = 0) THEN
   PSET (((xe2(contamagie2) - 1) * larghmagie) + j - 1, ((ye2(contamagie2) - 1) * altmagie) + i - 1), coloresfondo
  ELSE
   PSET (((xe2(contamagie2) - 1) * larghmagie) + j - 1, ((ye2(contamagie2) - 1) * altmagie) + i - 1), e2(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviMagia3
' scrivi le magie di tipo 3

FOR i = 1 TO altmagie
 FOR j = 1 TO larghmagie
  IF (e3(i, j) = 0) THEN
   PSET (((xe3(contamagie3) - 1) * larghmagie) + j - 1, ((ye3(contamagie3) - 1) * altmagie) + i - 1), coloresfondo
  ELSE
   PSET (((xe3(contamagie3) - 1) * larghmagie) + j - 1, ((ye3(contamagie3) - 1) * altmagie) + i - 1), e3(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviMedaglia1
' scrivi le medaglie di tipo 1

FOR i = 1 TO altmedaglie
 FOR j = 1 TO larghmedaglie
  IF (g1(i, j) = 0) THEN
   PSET (((xg1(contamedaglie1) - 1) * larghmedaglie) + j - 1, ((yg1(contamedaglie1) - 1) * altmedaglie) + i - 1), coloresfondo
  ELSE
   PSET (((xg1(contamedaglie1) - 1) * larghmedaglie) + j - 1, ((yg1(contamedaglie1) - 1) * altmedaglie) + i - 1), g1(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviMedaglia2
' scrivi le medaglie di tipo 2

FOR i = 1 TO altmedaglie
 FOR j = 1 TO larghmedaglie
  IF (g2(i, j) = 0) THEN
   PSET (((xg2(contamedaglie2) - 1) * larghmedaglie) + j - 1, ((yg2(contamedaglie2) - 1) * altmedaglie) + i - 1), coloresfondo
  ELSE
   PSET (((xg2(contamedaglie2) - 1) * larghmedaglie) + j - 1, ((yg2(contamedaglie2) - 1) * altmedaglie) + i - 1), g2(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviMuro
' disegna il muro

FOR i = 1 TO altmuro
 FOR j = 1 TO larghmuro
  IF (m(i, j) = 0) THEN
   PSET (((xm - 1) * larghmuro) + j - 1, ((ym - 1) * altmuro) + i - 1), coloresfondo
  ELSE
   PSET (((xm - 1) * larghmuro) + j - 1, ((ym - 1) * altmuro) + i - 1), m(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviNemico1
' disegna i nemici di tipo 1

' ripristina lo sfondo
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  PSET (((salvaxn1 - 1) * larghnemici) + j - 1, ((salvayn1 - 1) * altnemici) + i - 1), coloresfondo
 NEXT j
NEXT i

' disegna il nemico di tipo 1
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  IF (n1(i, j) = 0) THEN
   PSET (((xn1(contanemici1) - 1) * larghnemici) + j - 1, ((yn1(contanemici1) - 1) * altnemici) + i - 1), coloresfondo
  ELSE
   PSET (((xn1(contanemici1) - 1) * larghnemici) + j - 1, ((yn1(contanemici1) - 1) * altnemici) + i - 1), n1(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviNemico2
' disegna i nemici di tipo 2

' ripristina lo sfondo
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  PSET (((salvaxn2 - 1) * larghnemici) + j - 1, ((salvayn2 - 1) * altnemici) + i - 1), coloresfondo
 NEXT j
NEXT i

' disegna il nemico di tipo 2
FOR i = 1 TO altnemici
 FOR j = 1 TO larghnemici
  IF (n2(i, j) = 0) THEN
   PSET (((xn2(contanemici2) - 1) * larghnemici) + j - 1, ((yn2(contanemici2) - 1) * altnemici) + i - 1), coloresfondo
  ELSE
   PSET (((xn2(contanemici2) - 1) * larghnemici) + j - 1, ((yn2(contanemici2) - 1) * altnemici) + i - 1), n2(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB ScriviPersonaggio
' disegna il personaggio

' ripristina lo sfondo
FOR i = 1 TO altp
 FOR j = 1 TO larghp
  PSET (((xpold - 1) * larghp) + j - 1, ((ypold - 1) * altp) + i - 1), coloresfondo
 NEXT j
NEXT i

' disegna il personaggio
FOR i = 1 TO altp
 FOR j = 1 TO larghp
  IF (p(i, j) = 0) THEN
   PSET (((xpnew - 1) * larghp) + j - 1, ((ypnew - 1) * altp) + i - 1), coloresfondo
  ELSE
   PSET (((xpnew - 1) * larghp) + j - 1, ((ypnew - 1) * altp) + i - 1), p(i, j)
  END IF
 NEXT j
NEXT i

END SUB

SUB SuonoMagia
' effetto sonoro quando si prende una magia

SOUND 3000, 10

END SUB

SUB SuonoMedaglia1
' effetto sonoro quando si prende una medaglia di tipo 1

SOUND 2000, 10

END SUB

SUB SuonoMedaglia2
' effetto sonoro quando si prende una medaglia di tipo 2

SOUND 2500, 10

END SUB

SUB SuonoNoMedaglia
' effetto sonoro quando un nemico prende una medaglia

SOUND 1500, 10

END SUB

SUB SuonoSconfitta
' effetto sonoro quando si e' persa la partita

SOUND 1000, 20

END SUB

SUB SuonoVittoria
' effetto sonoro quando si vince e il gioco e' terminato

SOUND 3500, 25

END SUB

